#if !defined(CVTICW_H)
#define CVTICW_H

#if defined(__cplusplus)
extern "C" {
#endif

extern float (cvtiaf)(const char *, /*@null@*/ /*@out@*/ char **);
extern float (cvtibf)(const char *, /*@null@*/ /*@out@*/ char **);
extern float (cvtidf)(const char *, /*@null@*/ /*@out@*/ char **);
extern float (cvtigf)(const char *, /*@null@*/ /*@out@*/ char **);
extern float (cvtihf)(const char *, /*@null@*/ /*@out@*/ char **);
extern float (cvtiof)(const char *, /*@null@*/ /*@out@*/ char **);

extern double (cvtia)(const char *, /*@null@*/ /*@out@*/ char **);
extern double (cvtib)(const char *, /*@null@*/ /*@out@*/ char **);
extern double (cvtid)(const char *, /*@null@*/ /*@out@*/ char **);
extern double (cvtig)(const char *, /*@null@*/ /*@out@*/ char **);
extern double (cvtih)(const char *, /*@null@*/ /*@out@*/ char **);
extern double (cvtio)(const char *, /*@null@*/ /*@out@*/ char **);

#if defined(HAVE_LONG_DOUBLE)

extern long double (cvtial)(const char *, /*@null@*/ /*@out@*/ char **);
extern long double (cvtibl)(const char *, /*@null@*/ /*@out@*/ char **);
extern long double (cvtidl)(const char *, /*@null@*/ /*@out@*/ char **);
extern long double (cvtigl)(const char *, /*@null@*/ /*@out@*/ char **);
extern long double (cvtihl)(const char *, /*@null@*/ /*@out@*/ char **);
extern long double (cvtiol)(const char *, /*@null@*/ /*@out@*/ char **);

#endif /* defined(HAVE_LONG_DOUBLE) */

#if defined(HAVE_LONG_LONG_DOUBLE)

extern long_long_double (cvtiall)(const char *, /*@null@*/ /*@out@*/ char **);
extern long_long_double (cvtibll)(const char *, /*@null@*/ /*@out@*/ char **);
extern long_long_double (cvtidll)(const char *, /*@null@*/ /*@out@*/ char **);
extern long_long_double (cvtigll)(const char *, /*@null@*/ /*@out@*/ char **);
extern long_long_double (cvtihll)(const char *, /*@null@*/ /*@out@*/ char **);
extern long_long_double (cvtioll)(const char *, /*@null@*/ /*@out@*/ char **);

#endif /* defined(HAVE_LONG_LONG_DOUBLE) */

#if defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES)

/* NB: _FPWIDETYPES is set by the HP-UX IA-64 compilers in response to
   the -fpwidetypes command-line option, and  */

/* Mimic the HP-UX practice in <float.h>, <math.h>, and <stdlib.h> of
   providing typedefs of the user types extended and quad if they are
   not yet defined. */

#ifndef _INCLUDE_QUAD
typedef __float128 quad;
#define _INCLUDE_QUAD
#endif

#ifndef _INCLUDE_EXTENDED
typedef __float80 extended;
#define _INCLUDE_EXTENDED
#endif

extern __float80 (cvtiaw)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float80 (cvtibw)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float80 (cvtidw)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float80 (cvtigw)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float80 (cvtihw)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float80 (cvtiow)(const char *, /*@null@*/ /*@out@*/ char **);

extern __float128 (cvtiaq)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float128 (cvtibq)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float128 (cvtidq)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float128 (cvtigq)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float128 (cvtihq)(const char *, /*@null@*/ /*@out@*/ char **);
extern __float128 (cvtioq)(const char *, /*@null@*/ /*@out@*/ char **);

#endif /* defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES) */

#if defined(HAVE_DECIMAL)

extern decimal_float (cvtiadf)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_float (cvtibdf)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_float (cvtiddf)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_float (cvtigdf)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_float (cvtihdf)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_float (cvtiodf)(const char *, /*@null@*/ /*@out@*/ char **);

extern decimal_double (cvtiad)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_double (cvtibd)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_double (cvtidd)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_double (cvtigd)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_double (cvtihd)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_double (cvtiod)(const char *, /*@null@*/ /*@out@*/ char **);

#if defined(HAVE_DECIMAL_LONG_DOUBLE)

extern decimal_long_double (cvtiadl)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_double (cvtibdl)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_double (cvtiddl)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_double (cvtigdl)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_double (cvtihdl)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_double (cvtiodl)(const char *, /*@null@*/ /*@out@*/ char **);

#endif /* defined(HAVE_DECIMAL_LONG_DOUBLE) */

#if defined(HAVE_DECIMAL_LONG_LONG_DOUBLE)

extern decimal_long_long_double (cvtiadll)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_long_double (cvtibdll)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_long_double (cvtiddll)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_long_double (cvtigdll)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_long_double (cvtihdll)(const char *, /*@null@*/ /*@out@*/ char **);
extern decimal_long_long_double (cvtiodll)(const char *, /*@null@*/ /*@out@*/ char **);

#endif /* defined(HAVE_DECIMAL_LONG_LONG_DOUBLE) */

#endif /* defined(HAVE_DECIMAL) */

#if defined(__cplusplus)
}
#endif

#endif /* !defined(CVTICW_H) */
